package cz.upol;


//kazde kolo je dopravni prostredek (bike is a vehicle)
// ale nema SPZ, tedy ne RegisteredVehicle
//navic se o kolo clovek muze start sam 
public class Bike extends Vehicle implements SelfMaintanable {

    //kolo navic oproti obecnemu dopravnimu prostredku muze byt zavodni
    private boolean racingBike; 
    // a ma jedineho jezdce
    private Human rider;
    
    
    //konstruktory
    public Bike( String color, String location, int maxSpeed, int minSpeed, boolean isRacingBike) {
        super(color, location, maxSpeed, minSpeed, 1); //volame konsturktor predka
        this.racingBike = isRacingBike;
    }


    public boolean isRacingBike() {
        return racingBike;
    }

    public void setRacingBike(boolean isRacingBike) {
        this.racingBike = isRacingBike;
    }
    

    //menime implementaci metod z predka
    //anotace override zajistuje trochu vice kontorly prekladacem
    @Override
    public boolean board(Human human) {
        rider = human;
        return true;
    }

    @Override
    public boolean disembark(Human human) {
        if (human != null && human.equals(rider)) {
            rider = null;
            return true;
        }
        return false;
    }
    
    //implementuje metody vyzadovane rozhranimi
    @Override
    public boolean prepareToUse() {
       inflateWheels();
       checkBrakes();
       return true;
    }

    @Override
    public boolean isReady() {
      return checkBrakes();
    }
    
    
    //a pridame si nejakou jinou potrebnou funkcionalitu
    private boolean checkBrakes(){
        return true;
    }
    
    private void inflateWheels(){
        //...
    }
    
    public String ringRing(){
        return "RingRing!";
    }

  

}
