package cz.upol;

public class Main {

    public static void main(String[] args) {
        //vytvorime nejake instance dostupnych trid
        Car car = new Car("1T11111", "red", "Olomouc", 250, 200, -20, 2);
        Bike bike = new Bike("blue", "Praha", 30, 0, false);
        Bus bus = new Bus("AAA1111", "white", "Brno", 130, -15, 80, new String[]{"Praha", "Brno", "Paříž"});
        //Vehicle v = new Vehicle("red", "Olomouc"); //NELZE - abstraktní třída

        System.out.println("Auto je dopravni prostredek, registrovany, ma svetla a lze jej udrzovat sam, ale neni to kolo ani clovek:");
        System.out.println(car instanceof Vehicle);
        System.out.println(car instanceof RegisteredVehicle);
        System.out.println(car instanceof HasLights);
        System.out.println(car instanceof SelfMaintanable);
        System.out.println("Kolo to ma dost jinak:");
        System.out.println(bike instanceof Vehicle);
        System.out.println(bike instanceof HasLights);
        System.out.println(bike instanceof SelfMaintanable);
        System.out.println(bike instanceof Bike);

        //toho, ze kazda instance potomka je i instanci predka a implementovanych rozhrani se da pekne vyuzivat
        Vehicle[] allVehicles = new Vehicle[]{car, bike, bus};
        //tj se vsim, co je Vehicle, se da pracovat jako s Vehicle

        for (Vehicle v : allVehicles) {
            //hodne polymorfismu  - podivejte se, kdy se vola ktera metoda
            //tj i kdyz v je typu Vehicle, tak metody se volaji
            //dle skutecneho typu objektu ve v
            System.out.println("Jsem: " + v.toString());
            System.out.println("Jsem v: " + v.getLocation());
            System.out.println("mam jet do Ostravy");
            boolean res = v.setLocation("Ostrava");
            System.out.println("Povedlo se? " + res); //zajimave hlavne u autobusu
            System.out.println("Jsem v: " + v.getLocation());
        }

        // vsimnete si, ktera prepareToUse se vola u auta a ktera u kola
        System.out.println("Udrzba auta: ");
        System.out.println(car.prepareToUse());
        System.out.println("Udrzba kola: ");
        System.out.println(bike.prepareToUse());
    }
}
