
package cz.upol;

// dopravni prostredky s SPZ
// opet to nejsou vsechny informace, ktere potrebujeme pro existenci dopravniho
// prostredku v systemu, tedy abstract
public abstract class RegisteredVehicle extends Vehicle {
    
    private final String plateNo; //konstanta - po vytvoreni registrovanho vozu uz nelze menit
    
    
    public RegisteredVehicle(String plateNo, String color, String location, int maxSpeed, int minSpeed, int capacity) {
        super(color, location, maxSpeed, minSpeed, capacity);
        this.plateNo = plateNo;
    }

    public String getPlateNo() {
        return plateNo;
    }
    
    @Override
    public String toString(){
        return "Registrovane vozidlo s SPZ " + plateNo;
    }
    
}
